diff -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -u -N -r -E -B ./src/utils/lib/charset.mli ./src/utils/lib/charset.mli
--- ./src/utils/lib/charset.mli	1970-01-01 01:00:00.000000000 +0100
+++ ./src/utils/lib/charset.mli	2005-04-04 22:34:51.000000000 +0200
@@ -0,0 +1,147 @@
+(* Copyright 2005 b8_bavard, INRIA *)
+(*
+    This file is part of mldonkey.
+
+    mldonkey is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    mldonkey is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with mldonkey; if not, write to the Free Software
+    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*)
+
+type charset =
+| ANSI_X3_4_1968 | ANSI_X3_4_1986 | ASCII | CP367 | IBM367 | ISO_IR_6 | ISO646_US | ISO_646_IRV_1991 | US | US_ASCII | CSASCII
+| UTF_8
+| ISO_10646_UCS_2 | UCS_2 | CSUNICODE
+| UCS_2BE | UNICODE_1_1 | UNICODEBIG | CSUNICODE11
+| UCS_2LE | UNICODELITTLE
+| ISO_10646_UCS_4 | UCS_4 | CSUCS4
+| UCS_4BE
+| UCS_4LE
+| UTF_16
+| UTF_16BE
+| UTF_16LE
+| UTF_32
+| UTF_32BE
+| UTF_32LE
+| UNICODE_1_1_UTF_7 | UTF_7 | CSUNICODE11UTF7
+| UCS_2_INTERNAL
+| UCS_2_SWAPPED
+| UCS_4_INTERNAL
+| UCS_4_SWAPPED
+| C99
+| JAVA
+| CP819 | IBM819 | ISO_8859_1 | ISO_IR_100 | ISO8859_1 | ISO_8859_1_1987 | L1 | LATIN1 | CSISOLATIN1
+| ISO_8859_2 | ISO_IR_101 | ISO8859_2 | ISO_8859_2_1987 | L2 | LATIN2 | CSISOLATIN2
+| ISO_8859_3 | ISO_IR_109 | ISO8859_3 | ISO_8859_3_1988 | L3 | LATIN3 | CSISOLATIN3
+| ISO_8859_4 | ISO_IR_110 | ISO8859_4 | ISO_8859_4_1988 | L4 | LATIN4 | CSISOLATIN4
+| CYRILLIC | ISO_8859_5 | ISO_IR_144  | ISO8859_5 | ISO_8859_5_1988 | CSISOLATINCYRILLIC
+| ARABIC | ASMO_708 | ECMA_114 | ISO_8859_6 | ISO_IR_127 | ISO8859_6 | ISO_8859_6_1987 | CSISOLATINARABIC
+| ECMA_118 | ELOT_928 | GREEK | GREEK8 | ISO_8859_7 | ISO_IR_126 | ISO8859_7 | ISO_8859_7_1987 | CSISOLATINGREEK
+| HEBREW | ISO_8859_8 | ISO_IR_138 | ISO8859_8 | ISO_8859_8_1988 | CSISOLATINHEBREW
+| ISO_8859_9 | ISO_IR_148 | ISO8859_9 | ISO_8859_9_1989 | L5 | LATIN5 | CSISOLATIN5
+| ISO_8859_10 | ISO_IR_157 | ISO8859_10 | ISO_8859_10_1992 | L6 | LATIN6 | CSISOLATIN6
+| ISO_8859_13 | ISO_IR_179 | ISO8859_13 | L7 | LATIN7
+| ISO_8859_14 | ISO_CELTIC | ISO8859_14 | ISO_IR_199 | ISO_8859_14_1998 | L8 | LATIN8
+| ISO_8859_15 | ISO_IR_203 | ISO8859_15 | ISO_8859_15_1998
+| ISO_8859_16 | ISO_IR_226 | ISO8859_16 | ISO_8859_16_2000
+| KOI8_R | CSKOI8R
+| KOI8_U
+| KOI8_RU
+| CP1250 | MS_EE | WINDOWS_1250
+| CP1251 | MS_CYRL | WINDOWS_1251
+| CP1252 | MS_ANSI | WINDOWS_1252
+| CP1253 | MS_GREEK | WINDOWS_1253
+| CP1254 | MS_TURK | WINDOWS_1254
+| CP1255 | MS_HEBR | WINDOWS_1255
+| CP1256 | MS_ARAB | WINDOWS_1256
+| CP1257 | WINBALTRIM | WINDOWS_1257
+| CP1258 | WINDOWS_1258
+| I_850 | CP850 | IBM850 | CSPC850MULTILINGUAL
+| I_862 | CP862 | IBM862 | CSPC862LATINHEBREW
+| I_866 | CP866 | IBM866 | CSIBM866
+| MAC | MACINTOSH | MACROMAN | CSMACINTOSH
+| MACCENTRALEUROPE
+| MACICELAND
+| MACCROATIAN
+| MACROMANIA
+| MACCYRILLIC
+| MACUKRAINE
+| MACGREEK
+| MACTURKISH
+| MACHEBREW
+| MACARABIC
+| MACTHAI
+| HP_ROMAN8 | R8 | ROMAN8 | CSHPROMAN8
+| NEXTSTEP
+| ARMSCII_8
+| GEORGIAN_ACADEMY
+| GEORGIAN_PS
+| KOI8_T
+| MULELAO_1
+| CP1133 | IBM_CP1133
+| ISO_IR_166 | TIS_620 | TIS620 | TIS620_0 | TIS620_2529_1 | TIS620_2533_0 | TIS620_2533_1
+| CP874 | WINDOWS_874
+| VISCII | VISCII1_1_1 | CSVISCII
+| TCVN | TCVN_5712 | TCVN5712_1 | TCVN5712_1_1993
+| ISO_IR_14 | ISO646_JP | JIS_C6220_1969_RO | JP | CSISO14JISC6220RO
+| JISX0201_1976 | JIS_X0201 | X0201 | CSHALFWIDTHKATAKANA
+| ISO_IR_87 | JIS0208 | JIS_C6226_1983 | JIS_X0208 | JIS_X0208_1983 | JIS_X0208_1990 | X0208 | CSISO87JISX0208
+| ISO_IR_159 | JIS_X0212 | JIS_X0212_1990 | JIS_X0212_1990_0 | X0212 | CSISO159JISX02121990
+| CN | GB_1988_80 | ISO_IR_57 | ISO646_CN | CSISO57GB1988
+| CHINESE | GB_2312_80 | ISO_IR_58 | CSISO58GB231280
+| CN_GB_ISOIR165 | ISO_IR_165
+| ISO_IR_149 | KOREAN | KSC_5601 | KS_C_5601_1987 | KS_C_5601_1989 | CSKSC56011987
+| EUC_JP | EUCJP | EXTENDED_UNIX_CODE_PACKED_FORMAT_FOR_JAPANESE | CSEUCPKDFMTJAPANESE
+| MS_KANJI | SHIFT_JIS | SJIS | CSSHIFTJIS
+| CP932
+| ISO_2022_JP | CSISO2022JP
+| ISO_2022_JP_1
+| ISO_2022_JP_2 | CSISO2022JP2
+| CN_GB | EUC_CN | EUCCN | GB2312 | CSGB2312
+| CP936 | GBK
+| GB18030
+| ISO_2022_CN | CSISO2022CN
+| ISO_2022_CN_EXT
+| HZ | HZ_GB_2312
+| EUC_TW | EUCTW | CSEUCTW
+| BIG_5 | BIG_FIVE | BIG5 | BIGFIVE | CN_BIG5 | CSBIG5
+| CP950
+| BIG5_HKSCS | BIG5HKSCS
+| EUC_KR | EUCKR | CSEUCKR
+| CP949 | UHC
+| CP1361 | JOHAB
+| ISO_2022_KR | CSISO2022KR
+| I_437 | CP437 | IBM437 | CSPC8CODEPAGE437
+| CP737
+| CP775 | IBM775 | CSPC775BALTIC
+| I_852 | CP852 | IBM852 | CSPCP852
+| CP853
+| I_855 | CP855 | IBM855 | CSIBM855
+| I_857 | CP857 | IBM857 | CSIBM857
+| CP858
+| I_860 | CP860 | IBM860 | CSIBM860
+| I_861 | CP_IS | CP861 | IBM861 | CSIBM861
+| I_863 | CP863 | IBM863 | CSIBM863
+| CP864 | IBM864 | CSIBM864
+| I_865 | CP865 | IBM865 | CSIBM865
+| I_869 | CP_GR | CP869 | IBM869 | CSIBM869
+| CP1125
+
+(* convert ~from_charset ~to_charset s :
+ * raise CharsetError if the string [s] is not entirely convertible.
+ *)
+
+val convert : from_charset : charset -> to_charset : charset -> string -> string
+
+val is_utf8 : string -> bool
+val to_utf8 : string -> string
+val to_locale : string -> string
diff -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -u -N -r -E -B ./src/utils/lib/charsetstubs.c ./src/utils/lib/charsetstubs.c
--- ./src/utils/lib/charsetstubs.c	1970-01-01 01:00:00.000000000 +0100
+++ ./src/utils/lib/charsetstubs.c	2005-04-04 22:34:51.000000000 +0200
@@ -0,0 +1,349 @@
+/* Copyright 2005 b8_bavard, INRIA */
+/*
+    This file is part of mldonkey.
+
+    mldonkey is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    mldonkey is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with mldonkey; if not, write to the Free Software
+    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*/
+
+/* Stub code to interface with libiconv
+ *
+ * taken and modified from
+ *   glib-2.4.7/glib/gconvert.c
+ *   glib-2.4.7/glib/gutf8.c
+ *   lablgtk-2.4.0/src/ml_glib.c
+ *   libiconv-1.9.1/src/iconv.c
+ *
+ */
+
+#include <stdio.h>
+#include <string.h>
+#include <localcharset.h>
+#include <iconv.h>
+
+#include <caml/mlvalues.h>
+#include <caml/alloc.h>
+#include <caml/callback.h>
+#include <caml/fail.h>
+#include <caml/memory.h>
+
+#define FALSE 0
+#define TRUE  1
+
+#define SizedString_val(x) String_val(x), string_length(x)
+
+#define UTF8_COMPUTE(Char, Mask, Len)					      \
+  if (Char < 128)							      \
+    {									      \
+      Len = 1;								      \
+      Mask = 0x7f;							      \
+    }									      \
+  else if ((Char & 0xe0) == 0xc0)					      \
+    {									      \
+      Len = 2;								      \
+      Mask = 0x1f;							      \
+    }									      \
+  else if ((Char & 0xf0) == 0xe0)					      \
+    {									      \
+      Len = 3;								      \
+      Mask = 0x0f;							      \
+    }									      \
+  else if ((Char & 0xf8) == 0xf0)					      \
+    {									      \
+      Len = 4;								      \
+      Mask = 0x07;							      \
+    }									      \
+  else if ((Char & 0xfc) == 0xf8)					      \
+    {									      \
+      Len = 5;								      \
+      Mask = 0x03;							      \
+    }									      \
+  else if ((Char & 0xfe) == 0xfc)					      \
+    {									      \
+      Len = 6;								      \
+      Mask = 0x01;							      \
+    }									      \
+  else									      \
+    Len = -1;
+
+#define UTF8_LENGTH(Char)              \
+  ((Char) < 0x80 ? 1 :                 \
+   ((Char) < 0x800 ? 2 :               \
+    ((Char) < 0x10000 ? 3 :            \
+     ((Char) < 0x200000 ? 4 :          \
+      ((Char) < 0x4000000 ? 5 : 6)))))
+   
+
+#define UTF8_GET(Result, Chars, Count, Mask, Len)			      \
+  (Result) = (Chars)[0] & (Mask);					      \
+  for ((Count) = 1; (Count) < (Len); ++(Count))				      \
+    {									      \
+      if (((Chars)[(Count)] & 0xc0) != 0x80)				      \
+	{								      \
+	  (Result) = -1;						      \
+	  break;							      \
+	}								      \
+      (Result) <<= 6;							      \
+      (Result) |= ((Chars)[(Count)] & 0x3f);				      \
+    }
+
+#define UNICODE_VALID(Char)                   \
+    ((Char) < 0x110000 &&                     \
+     (((Char) & 0xFFFFF800) != 0xD800) &&     \
+     ((Char) < 0xFDD0 || (Char) > 0xFDEF) &&  \
+     ((Char) & 0xFFFE) != 0xFFFE)
+
+void
+raise_error(void)
+{
+  static value * closure_f = NULL;
+  if (closure_f == NULL) {
+    /* First time around, look up by name */
+    closure_f = caml_named_value("charset_error");
+  }
+  raise_constant(*closure_f);
+}
+
+int
+utf8_validate (const char  *str,
+               size_t      max_len,    
+               const char  **end)
+{
+
+  const char *p;
+
+  if (str == NULL)
+    return FALSE;
+
+  if (end)
+    *end = str;
+  
+  p = str;
+  
+  while ((max_len < 0 || (p - str) < max_len) && *p)
+    {
+      int i, mask = 0, len;
+      unsigned int result;
+      unsigned char c = (unsigned char) *p;
+      
+      UTF8_COMPUTE (c, mask, len);
+
+      if (len == -1)
+        break;
+
+      /* check that the expected number of bytes exists in str */
+      if (max_len >= 0 &&
+          ((max_len - (p - str)) < len))
+        break;
+        
+      UTF8_GET (result, p, i, mask, len);
+
+      if (UTF8_LENGTH (result) != len) /* Check for overlong UTF-8 */
+	break;
+
+      if (result == (unsigned int)-1)
+        break;
+
+      if (!UNICODE_VALID (result))
+	break;
+      
+      p += len;
+    }
+
+  if (end)
+    *end = p;
+
+  /* See that we covered the entire length if a length was
+   * passed in, or that we ended on a nul if not
+   */
+  if (max_len >= 0 &&
+      p != (str + max_len))
+    return FALSE;
+  else if (max_len < 0 &&
+           *p != '\0')
+    return FALSE;
+  else
+    return TRUE;
+}
+
+size_t 
+ml_iconv (iconv_t cd,
+          char    **inbuf,
+          size_t  *inbytes_left,
+          char    **outbuf,
+          size_t  *outbytes_left)
+{
+  return iconv (cd, inbuf, inbytes_left, outbuf, outbytes_left);
+}
+
+char*
+ml_convert_with_iconv (const char *str,
+                       size_t     len,
+                       iconv_t    cd,
+                       size_t     *bytes_read, 
+                       size_t     *bytes_written)
+{
+  char *dest;
+  char *outp;
+  const char *p;
+  size_t inbytes_remaining;
+  size_t outbytes_remaining;
+  size_t outbuf_size;
+  size_t err;
+  int have_error = FALSE;
+
+  if (len < 0)
+    len = strlen (str);
+
+  p = str;
+  inbytes_remaining = len;
+  outbuf_size = len + 1; /* + 1 for nul in case len == 1 */
+  
+  outbytes_remaining = outbuf_size - 1; /* -1 for nul */
+  outp = dest = malloc (outbuf_size);
+
+ again:
+  
+  err = ml_iconv (cd, (char **)&p, &inbytes_remaining, &outp, &outbytes_remaining);
+
+  if (err == (size_t) -1)
+    {
+      switch (errno)
+	{
+	case EINVAL:
+	  /* Incomplete text, do not report an error */
+	  break;
+	case E2BIG:
+	  {
+	    size_t used = outp - dest;
+
+	    outbuf_size *= 2;
+	    dest = realloc (dest, outbuf_size);
+		
+	    outp = dest + used;
+	    outbytes_remaining = outbuf_size - used - 1; /* -1 for nul */
+
+	    goto again;
+	  }
+	case EILSEQ:
+	  have_error = TRUE;
+	  break;
+	default:
+	  have_error = TRUE;
+	  break;
+	}
+    }
+
+  *outp = '\0';
+  
+  if (bytes_read)
+    *bytes_read = p - str;
+  else
+    {
+      if ((p - str) != len) 
+	{
+          if (!have_error)
+            {
+              have_error = TRUE;
+            }
+	}
+    }
+
+  if (bytes_written)
+    *bytes_written = outp - dest;	/* Doesn't include '\0' */
+
+  if (have_error)
+    {
+      free (dest);
+      return NULL;
+    }
+  else
+    return dest;
+}
+
+char*
+ml_convert (const char *str,
+            size_t     len,  
+            const char *to_codeset,
+            const char *from_codeset,
+            size_t     *bytes_read, 
+	    size_t     *bytes_written)
+{
+  char *res;
+  iconv_t cd;
+
+  cd = iconv_open (to_codeset, from_codeset);
+
+  if (cd == (iconv_t) -1)
+    {
+      if (bytes_read)
+        *bytes_read = 0;
+      
+      if (bytes_written)
+        *bytes_written = 0;
+      
+      return NULL;
+    }
+
+  res = ml_convert_with_iconv (str, len, cd,
+			      bytes_read, bytes_written);
+  
+  iconv_close (cd);
+
+  return res;
+}
+
+static value
+ml_copy_string_len_and_free (char *str, size_t len)
+{
+  value v;
+
+  if (!str)
+    raise_error ();
+
+  v = alloc_string (len);
+  memcpy (String_val(v), str, len);
+  free (str);
+  return v;
+}
+
+value ml_convert_string(value str, value to, value from)
+{
+  size_t bw = 0;
+  char* c_res;
+
+  c_res = ml_convert(String_val(str),string_length(str),
+                    String_val(to),String_val(from),
+                    NULL,&bw);
+
+  return ml_copy_string_len_and_free (c_res, bw);
+}
+
+value ml_utf8_validate(value s)
+{
+  return Val_bool(utf8_validate(SizedString_val(s),NULL));
+}
+
+value ml_locale_charset(void)
+{
+
+  const char *str;
+
+  str = locale_charset ();
+
+  if (!str)
+    raise_error ();
+
+  return (copy_string ((char*) str));
+}
